#Dans Terminal:
#jupyter lab
#python tp1.py


import matplotlib.pyplot as plt
import numpy as np


A0=np.diag(np.array([-2,1,1])) # cas 1
A1=np.diag(np.array([-2,-2,1])) # cas 1
A2=np.diag(np.array([-2,2,1])) # cas 1
A3=np.diag(np.array([2,2,1]))+np.diag(np.array([1,0]),+1) # cas 3
A4=np.diag(np.array([2,1,1]))+np.diag(np.array([0,1]),+1) # cas 2

eps=1e-3
imax=50


#A_0

print('A0=',np.diag(np.array([-2,1,1])))
x0=np.random.rand(3)-np.random.rand(3)
crit=1
i=0
tab_crit=np.zeros(imax)
while (crit>eps) and (i<imax):
    y=np.dot(A0,x0)
    nu=np.dot(x0,y)
    x0=y/np.linalg.norm(y)
    crit=np.linalg.norm(x0[1:])
    tab_crit[i]=crit
    i=i+1
    
plt.plot(np.log(tab_crit[:i]))
plt.title('Matrice A0:')
plt.show()
         
    
print('lambda=',nu)
print('premier vecteur propre:',x0,'à',crit,'près et en ',i,'pas')

#A_1
print('A1=',np.diag(np.array([-2,-2,1])))

x0=np.random.rand(3)-np.random.rand(3)
crit=1
i=0
tab_crit=np.zeros(imax)
while (crit>eps) and (i<imax):
    y=np.dot(A1,x0)
    nu=np.dot(x0,y)
    x0=y/np.linalg.norm(y)
    crit=np.abs(x0[2])
    #np.linalg.norm(x0[1:])
    tab_crit[i]=crit
    i=i+1
    
plt.plot(np.log(tab_crit[:i]))
plt.title('Matrice A1:')
plt.show()

    
print('lambda=',nu)
print('premier vecteur propre:',x0,'à',crit,'près et en ',i,'pas')

#A_2
print('A2=',np.diag(np.array([-2,2,1])))

x0=np.random.rand(3)-np.random.rand(3)
crit=1
i=0
tab_crit=np.zeros(imax)
while (crit>eps) and (i<imax):
    y=np.dot(A2,x0)
    nu=np.dot(x0,y)
    x0=y/np.linalg.norm(y)
    crit=np.abs(x0[2])
    #np.linalg.norm(x0[1:])
    tab_crit[i]=crit
    i=i+1
    
plt.plot(np.log(tab_crit[:i]))
plt.title('Matrice A2:')
plt.show()

    
print('lambda=',nu)
print('premier vecteur propre:',x0,'à',crit,'près et en ',i,'pas')

#A_3
print('A3=',np.diag(np.array([2,2,1]))+np.diag(np.array([1,0]),+1))

x0=np.random.rand(3)-np.random.rand(3)
crit=1
i=0
tab_crit=np.zeros(imax)
tab_compt=np.zeros(imax)
while (crit>eps) and (i<imax):
    y=np.dot(A3,x0)
    nu=np.dot(x0,y)
    x0=y/np.linalg.norm(y)
    crit=np.linalg.norm(x0[1:])
    tab_crit[i]=crit
    tab_compt[i]=1/(i+1)
    i=i+1
    

    
plt.plot(tab_crit[:i])
plt.plot(tab_compt[:i])
plt.title('Matrice A3:')
plt.show()

    
print('lambda=',nu)
print('premier vecteur propre:',x0,'à',crit,'près et en ',i,'pas')

#A_4
print('A4=',np.diag(np.array([2,1,1]))+np.diag(np.array([0,1]),+1))

x0=np.random.rand(3)-np.random.rand(3)
crit=1
i=0
tab_crit=np.zeros(imax)
while (crit>eps) and (i<imax):
    y=np.dot(A4,x0)
    nu=np.dot(x0,y)
    x0=y/np.linalg.norm(y)
    crit=np.linalg.norm(x0[1:])
    tab_crit[i]=crit/(i+1)
    i=i+1
    
plt.plot(np.log(tab_crit[:i]))
plt.title('Matrice A4:')
plt.show()

    
print('lambda=',nu)
print('premier vecteur propre:',x0,'à',crit,'près et en ',i,'pas')

# lambda non défective ssi Les blocs de Jordan associés à λ sont tous de taille 1
    
    


           